diff --git a/gcc/ChangeLog b/gcc/ChangeLog
index caf4aa4..b0f30f1 100644
--- a/gcc/ChangeLog
+++ b/gcc/ChangeLog
@@ -1,5 +1,21 @@
 2010-08-02  Andreas Simbuerger  <simbuerg@fim.uni-passau.de>
 
+	* graphite-cloog-util.h: Added cloog.h.
+	* graphite-blocking.c: Removed cloog.h.
+	* graphite-dependences.c: Same.
+	* graphite-interchange.c: Same.
+	* graphite-poly.c: Same.
+	* graphite-ppl.c: Same.
+	* graphite-scop-detection.c: Same.
+	* graphite-sese-to-poly.c:
+	Removed cloog.h.
+	Removed graphite-clast-to-gimple.h.
+	(check_poly_representation): Removed (unused).
+	* graphite-sese-to-poly.h
+	(check_poly_representation): Removed (unused).
+
+2010-08-02  Andreas Simbuerger  <simbuerg@fim.uni-passau.de>
+
 	* Makefile.in (OBJS-common): Added graphite-cloog-util.o.
 	(graphite-clast-to-gimple.o): Added graphite-cloog-util.h.
 	(graphite-cloog-util.o): New.
diff --git a/gcc/ChangeLog.graphite b/gcc/ChangeLog.graphite
index b1c1e8e..5ef7688 100644
--- a/gcc/ChangeLog.graphite
+++ b/gcc/ChangeLog.graphite
@@ -1,5 +1,21 @@
 2010-07-05  Andreas Simbuerger  <simbuerg@fim.uni-passau.de>
 
+	* graphite-cloog-util.h: Added cloog.h.
+	* graphite-blocking.c: Removed cloog.h.
+	* graphite-dependences.c: Same.
+	* graphite-interchange.c: Same.
+	* graphite-poly.c: Same.
+	* graphite-ppl.c: Same.
+	* graphite-scop-detection.c: Same.
+	* graphite-sese-to-poly.c:
+	Removed cloog.h.
+	Removed graphite-clast-to-gimple.h.
+	(check_poly_representation): Removed (unused).
+	* graphite-sese-to-poly.h
+	(check_poly_representation): Removed (unused).
+
+2010-07-05  Andreas Simbuerger  <simbuerg@fim.uni-passau.de>
+
 	* Makefile.in
 	(OBJS-common): Added graphite-cloog-util.o.
 	(graphite-clast-to-gimple.o): Added graphite-cloog-util.h.
diff --git a/gcc/graphite-blocking.c b/gcc/graphite-blocking.c
index 769cda4..deb25ec 100644
--- a/gcc/graphite-blocking.c
+++ b/gcc/graphite-blocking.c
@@ -46,7 +46,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "params.h"
 
 #ifdef HAVE_cloog
-#include "cloog/cloog.h"
 #include "ppl_c.h"
 #include "sese.h"
 #include "graphite-ppl.h"
diff --git a/gcc/graphite-cloog-util.h b/gcc/graphite-cloog-util.h
index 17a3be4..3180b0e 100644
--- a/gcc/graphite-cloog-util.h
+++ b/gcc/graphite-cloog-util.h
@@ -21,6 +21,8 @@ along with GCC; see the file COPYING3.  If not see
 #ifndef GRAPHITE_CLOOG_UTIL_H
 #define GRAPHITE_CLOOG_UTIL_H
 
+#include "cloog/cloog.h"
+
 CloogMatrix *new_Cloog_Matrix_from_ppl_Polyhedron (ppl_const_Polyhedron_t);
 CloogDomain *new_Cloog_Domain_from_ppl_Polyhedron (ppl_const_Polyhedron_t);
 CloogDomain * new_Cloog_Domain_from_ppl_Pointset_Powerset (
diff --git a/gcc/graphite-dependences.c b/gcc/graphite-dependences.c
index af4c962..3f13ac3 100644
--- a/gcc/graphite-dependences.c
+++ b/gcc/graphite-dependences.c
@@ -42,7 +42,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "gimple.h"
 
 #ifdef HAVE_cloog
-#include "cloog/cloog.h"
 #include "ppl_c.h"
 #include "sese.h"
 #include "graphite-ppl.h"
diff --git a/gcc/graphite-interchange.c b/gcc/graphite-interchange.c
index de3bf25..2392ce8 100644
--- a/gcc/graphite-interchange.c
+++ b/gcc/graphite-interchange.c
@@ -46,7 +46,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "params.h"
 
 #ifdef HAVE_cloog
-#include "cloog/cloog.h"
 #include "ppl_c.h"
 #include "sese.h"
 #include "graphite-ppl.h"
diff --git a/gcc/graphite-poly.c b/gcc/graphite-poly.c
index 5c4a6f9..67b9384 100644
--- a/gcc/graphite-poly.c
+++ b/gcc/graphite-poly.c
@@ -46,7 +46,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "params.h"
 
 #ifdef HAVE_cloog
-#include "cloog/cloog.h"
 #include "ppl_c.h"
 #include "sese.h"
 #include "graphite-ppl.h"
diff --git a/gcc/graphite-ppl.c b/gcc/graphite-ppl.c
index 9dd98bb..f87f345 100644
--- a/gcc/graphite-ppl.c
+++ b/gcc/graphite-ppl.c
@@ -28,7 +28,6 @@ along with GCC; see the file COPYING3.  If not see
 #ifdef HAVE_cloog
 
 #include "ppl_c.h"
-#include "cloog/cloog.h"
 #include "graphite-cloog-util.h"
 #include "graphite-ppl.h"
 
diff --git a/gcc/graphite-scop-detection.c b/gcc/graphite-scop-detection.c
index 36a5215..baa4c34 100644
--- a/gcc/graphite-scop-detection.c
+++ b/gcc/graphite-scop-detection.c
@@ -44,7 +44,6 @@ along with GCC; see the file COPYING3.  If not see
 #include "sese.h"
 
 #ifdef HAVE_cloog
-#include "cloog/cloog.h"
 #include "ppl_c.h"
 #include "graphite-ppl.h"
 #include "graphite.h"
diff --git a/gcc/graphite-sese-to-poly.c b/gcc/graphite-sese-to-poly.c
index 62064c4..ac251ab 100644
--- a/gcc/graphite-sese-to-poly.c
+++ b/gcc/graphite-sese-to-poly.c
@@ -43,13 +43,11 @@ along with GCC; see the file COPYING3.  If not see
 #include "sese.h"
 
 #ifdef HAVE_cloog
-#include "cloog/cloog.h"
 #include "ppl_c.h"
 #include "graphite-ppl.h"
 #include "graphite.h"
 #include "graphite-poly.h"
 #include "graphite-scop-detection.h"
-#include "graphite-clast-to-gimple.h"
 #include "graphite-sese-to-poly.h"
 
 /* Check if VAR is used in a phi node, that is no loop header.  */
@@ -3028,16 +3026,4 @@ build_poly_scop (scop_p scop)
      representation.  */
   POLY_SCOP_P (scop) = true;
 }
-
-/* Always return false.  Exercise the scop_to_clast function.  */
-
-void
-check_poly_representation (scop_p scop ATTRIBUTE_UNUSED)
-{
-#ifdef ENABLE_CHECKING
-  cloog_prog_clast pc = scop_to_clast (scop);
-  cloog_clast_free (pc.stmt);
-  cloog_program_free (pc.prog);
-#endif
-}
 #endif
diff --git a/gcc/graphite-sese-to-poly.h b/gcc/graphite-sese-to-poly.h
index 558a283..b0053d0 100644
--- a/gcc/graphite-sese-to-poly.h
+++ b/gcc/graphite-sese-to-poly.h
@@ -29,7 +29,6 @@ struct base_alias_pair
 };
 
 void build_poly_scop (scop_p);
-void check_poly_representation (scop_p);
 void rewrite_commutative_reductions_out_of_ssa (sese, sbitmap);
 void rewrite_reductions_out_of_ssa (scop_p);
 void rewrite_cross_bb_scalar_deps_out_of_ssa (scop_p);